<?php 
/*
Plugin Name: bbPress - Sort topic replies
Description: Sort topic replies in ascending or descending order for each bbPress forum
Author: Atif Naveed
Version: 1.0.0
Author URI: http://sandyrig.com/about
*/

// No direct access
if ( !defined( 'ABSPATH' ) ) exit;

// Sort the replies
// Checks if the topic bieng loaded belongs to a forum that has be checked to show replies sorted in descending order
// If True, sorts all the replies in descending order on datetime
add_filter('bbp_has_replies_query','bbp_reverse_reply_order');
function bbp_reverse_reply_order( $query = array() ) {
	$bbPress_post_id = get_the_ID();
	$bbPress_post_type = get_post_type($bbPress_post_id);
	
	$bbPress_forum_id = get_post_meta($bbPress_post_id, '_bbp_forum_id', true);
	$bbPress_sort_status = get_post_meta($bbPress_forum_id, '_bbp_sort_desc', true);
	if( $bbPress_post_type =='topic' && $bbPress_sort_status == 'desc' ){
		$query['order']='DESC';
		return $query;
	}
	
	return $query;
}


// Adds meta box to the side bar of the Forums edit pages
add_action( 'add_meta_boxes', 'bbPress_meta_box_add' );
function bbPress_meta_box_add()
{
	add_meta_box( 'bbPress_meta_box_sort_desc', 'Sort Replies', 'bbPress_meta_box', 'forum', 'side', 'high' );
}

// The content of the meta box
function bbPress_meta_box($post){
	$bbPress_sort_status = get_post_meta($post->ID, '_bbp_sort_desc', true);
	?>
	<p>
		<strong class="label">Order by</strong>
		<select name="sort-replies" id="sort-replies" >
			<option value="asc" <?php echo $bbPress_sort_status=="asc"?"selected='selected'":""; ?>>Ascending</option>
			<option value="desc" <?php echo $bbPress_sort_status=="desc"?"selected='selected'":""; ?>>Descending</option>
		</select>
		
	</p>
	<?php 
}

// Saves the meta box settings when the page is saved/updated/published
add_action( 'save_post', 'bbPress_meta_box_save' );
function bbPress_meta_box_save($post_id){
	if( $_POST['save'] ){
		if( $_POST['sort-replies'] == "desc" ){
			update_post_meta($post_id, '_bbp_sort_desc', 'desc');
		}else{
			update_post_meta($post_id, '_bbp_sort_desc', 'asc');
		}
	}
	
}



?>